package it.unibo.cs.lbedogni.database;

import android.app.Activity;
import android.content.Intent;
import android.database.Cursor;
import android.os.Bundle;
import android.text.Html;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TextView;

public class DatabaseActivity extends Activity implements OnClickListener {
	private static DBHelper dbh;
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        TextView tvMain = (TextView)findViewById(R.id.tv_main);
        tvMain.setText(Html.fromHtml("Welcome in my <b>Database</b> application. Below, you can see all the students <i>registered</i> in the database. <br><br>"
        		+ "Pressing <b>MENU</b> will give you some more options"));
        
        dbh = new DBHelper(this);
        

    }

	@Override
	protected void onResume() {
		super.onResume();
		LinearLayout ll = (LinearLayout)findViewById(R.id.mainLayout);

		Cursor cursor = dbh.getGrades();
		cursor.moveToFirst();

		while (!cursor.isAfterLast()) {

			TextView tv = new TextView(this);
			ViewGroup.LayoutParams lp = new ViewGroup.LayoutParams(ViewGroup.LayoutParams.WRAP_CONTENT, ViewGroup.LayoutParams.WRAP_CONTENT);
			tv.setLayoutParams(lp);

			LinearLayout newLL = new LinearLayout(this);
			ViewGroup.LayoutParams newLP = new ViewGroup.LayoutParams(ViewGroup.LayoutParams.FILL_PARENT, ViewGroup.LayoutParams.WRAP_CONTENT);
			newLL.setLayoutParams(newLP);
			newLL.setOrientation(LinearLayout.HORIZONTAL);

			boolean haveToContinue = false;
			int id = cursor.getInt(cursor.getColumnIndex(DBHelper.COLUMN_ID));
			for (int i =0; i < ll.getChildCount(); i++) {
				if (id == ll.getChildAt(i).getId()) {
					// We already added this view
					haveToContinue = true;
					Log.v("MY","DUPLICATE");
				} else {
					Log.v("MY",String.valueOf(ll.getChildAt(i).getId()));
				}
			}
			if (!haveToContinue) {
				newLL.setId(id);
				String firstName = cursor.getString(cursor.getColumnIndex(DBHelper.COLUMN_FIRST_NAME));
				String lastName = cursor.getString(cursor.getColumnIndex(DBHelper.COLUMN_LAST_NAME));
				String className = cursor.getString(cursor.getColumnIndex(DBHelper.COLUMN_CLASS));
				String grade = cursor.getString(cursor.getColumnIndex(DBHelper.COLUMN_GRADE));

				String toWrite = firstName + " " + lastName + " - " + className + " - " + grade;

				tv.setId(id);

				tv.setText(toWrite);

				newLL.addView(tv);

				Button btn = new Button(this);
				btn.setBackgroundResource(R.color.Red);
				btn.setPadding(0, 0, 0, 0);

				btn.setText("Delete");
				btn.setId(id);
				btn.setLayoutParams(lp);

				btn.setOnClickListener(this);

				newLL.addView(btn);

				ll.addView(newLL);
			}

			cursor.moveToNext();
		}
		cursor.close();
	}

	@Override
    public boolean onCreateOptionsMenu(Menu menu) {
    	Intent add = new Intent(this, AddStudent.class);
    	menu.add("Add Student").setIntent(add);
    	
    	Intent t = new Intent(this, Thirty.class);
    	menu.add("Show 30's").setIntent(t);
    	
    	return true;
    }
    
    public static DBHelper getDBHelper() {
    	return dbh;
    }

	@Override
	public void onClick(View v) {
		// Get the id from the view
		int id = v.getId();
		dbh.deleteStudent(id);
		
		Intent i = new Intent(this, DatabaseActivity.class);
		finish();
		startActivity(i);
		
	}
}